(use-package paredit
  :ensure t
  :config
  (autoload 'enable-paredit-mode "paredit" "Turn on pseudo-structural editing of Lisp code." t)
  :hook
  (emacs-lisp-mode . enable-paredit-mode)
  (eval-expression-minibuffer-setup enable-paredit-mode)
  (ielm-mode . enable-paredit-mode)
  (lisp-mode . enable-paredit-mode)
  (lisp-interaction-mode . enable-paredit-mode)
  (scheme-mode . enable-paredit-mode))

(use-package highlight-parentheses
  :ensure t
  :config
  (global-highlight-parentheses-mode t))

(use-package rainbow-delimiters
  :ensure t
  :hook
  (prog-mode . rainbow-delimiters-mode)
  :custom-face
  (rainbow-delimiters-depth-2-face ((t (:inherit rainbow-delimiters-base-face :foreground "cornflower blue"))))
  (rainbow-delimiters-depth-3-face ((t (:inherit rainbow-delimiters-base-face :foreground "sandy brown"))))
  (rainbow-delimiters-depth-4-face ((t (:inherit rainbow-delimiters-base-face :foreground "yellow green"))))
  (rainbow-delimiters-depth-5-face ((t (:inherit rainbow-delimiters-base-face :foreground "powder blue"))))
  (rainbow-delimiters-depth-6-face ((t (:inherit rainbow-delimiters-base-face :foreground "orchid"))))
  (rainbow-delimiters-depth-7-face ((t (:inherit rainbow-delimiters-base-face :foreground "lemon chiffon"))))
  (rainbow-delimiters-depth-8-face ((t (:inherit rainbow-delimiters-base-face :foreground "goldenrod"))))
  (rainbow-delimiters-depth-9-face ((t (:inherit rainbow-delimiters-base-face :foreground "dark cyan")))))

;; Hack to show only files known to git inside dired; needs the
;; `git-find' shell script shim (taken from :open https://r0tty.org/git/dotfiles/emacs/tree/.emacs.d/config/development.el)
(defun git-dired (dir)
  (interactive (list (read-directory-name "Find files in directory: " nil "" t)))
  (let ((find-program "git-find"))
    (find-dired dir "")))

;; python
;; (defun my-shell-mode-hook ()
;;   (add-hook
;;    'comint-output-filter-functions
;;    'python-pdbtrack-comint-output-filter-function t))
;; (add-hook 'shell-mode-hook 'my-shell-mode-hook)

;; enable flyspell checks for comments in code
(add-hook 'prog-mode-hook #'flyspell-prog-mode)

(use-package lsp-mode
  :ensure t
  :hook
  (rust-mode . lsp-deferred)
  (toml-mode . lsp-deferred)
  :config
  (lsp-inlay-hints-mode)
  (setq lsp-inlay-hint-enable t))
